diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index ef5b34a312..af4d1dcc2f 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -15446,7 +15446,7 @@ RemoveInheritance(Relation child_rel, Relation parent_rel, bool expect_detached)
 							  true, NULL, 1, key);
 	while (HeapTupleIsValid(attributeTuple = systable_getnext(scan)))
 	{
-		Form_pg_attribute att = (Form_pg_attribute) GETSTRUCT(attributeTuple);
+		Form_pg_attribute att = GETSTRUCT(pg_attribute, attributeTuple);
 
 		/* Ignore if dropped or not inherited */
 		if (att->attisdropped)
@@ -15459,7 +15459,7 @@ RemoveInheritance(Relation child_rel, Relation parent_rel, bool expect_detached)
 		{
 			/* Decrement inhcount and possibly set islocal to true */
 			HeapTuple	copyTuple = heap_copytuple(attributeTuple);
-			Form_pg_attribute copy_att = (Form_pg_attribute) GETSTRUCT(copyTuple);
+			Form_pg_attribute copy_att = GETSTRUCT(pg_attribute, copyTuple);
 
 			copy_att->attinhcount--;
 			if (copy_att->attinhcount == 0)
@@ -15490,7 +15490,7 @@ RemoveInheritance(Relation child_rel, Relation parent_rel, bool expect_detached)
 
 	while (HeapTupleIsValid(constraintTuple = systable_getnext(scan)))
 	{
-		Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(constraintTuple);
+		Form_pg_constraint con = GETSTRUCT(pg_constraint, constraintTuple);
 
 		if (con->contype == CONSTRAINT_CHECK)
 			connames = lappend(connames, pstrdup(NameStr(con->conname)));
@@ -15508,7 +15508,7 @@ RemoveInheritance(Relation child_rel, Relation parent_rel, bool expect_detached)
 
 	while (HeapTupleIsValid(constraintTuple = systable_getnext(scan)))
 	{
-		Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(constraintTuple);
+		Form_pg_constraint con = GETSTRUCT(pg_constraint, constraintTuple);
 		bool		match;
 		ListCell   *lc;
 
@@ -15529,7 +15529,7 @@ RemoveInheritance(Relation child_rel, Relation parent_rel, bool expect_detached)
 		{
 			/* Decrement inhcount and possibly set islocal to true */
 			HeapTuple	copyTuple = heap_copytuple(constraintTuple);
-			Form_pg_constraint copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
+			Form_pg_constraint copy_con = GETSTRUCT(pg_constraint, copyTuple);
 
 			if (copy_con->coninhcount <= 0) /* shouldn't happen */
 				elog(ERROR, "relation %u has non-inherited constraint \"%s\"",
@@ -15598,7 +15598,7 @@ drop_parent_dependency(Oid relid, Oid refclassid, Oid refobjid,
 
 	while (HeapTupleIsValid(depTuple = systable_getnext(scan)))
 	{
-		Form_pg_depend dep = (Form_pg_depend) GETSTRUCT(depTuple);
+		Form_pg_depend dep = GETSTRUCT(pg_depend, depTuple);
 
 		if (dep->refclassid == refclassid &&
 			dep->refobjid == refobjid &&
@@ -15643,7 +15643,7 @@ ATExecAddOf(Relation rel, const TypeName *ofTypename, LOCKMODE lockmode)
 	/* Validate the type. */
 	typetuple = typenameType(NULL, ofTypename, NULL);
 	check_of_type(typetuple);
-	typeform = (Form_pg_type) GETSTRUCT(typetuple);
+	typeform = GETSTRUCT(pg_type, typetuple);
 	typeid = typeform->oid;
 
 	/* Fail if the table has any inheritance parents. */
@@ -15744,7 +15744,7 @@ ATExecAddOf(Relation rel, const TypeName *ofTypename, LOCKMODE lockmode)
 	classtuple = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(classtuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
-	((Form_pg_class) GETSTRUCT(classtuple))->reloftype = typeid;
+	(GETSTRUCT(pg_class, classtuple))->reloftype = typeid;
 	CatalogTupleUpdate(relationRelation, &classtuple->t_self, classtuple);
 
 	InvokeObjectPostAlterHook(RelationRelationId, relid, 0);
@@ -15789,7 +15789,7 @@ ATExecDropOf(Relation rel, LOCKMODE lockmode)
 	tuple = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
-	((Form_pg_class) GETSTRUCT(tuple))->reloftype = InvalidOid;
+	(GETSTRUCT(pg_class, tuple))->reloftype = InvalidOid;
 	CatalogTupleUpdate(relationRelation, &tuple->t_self, tuple);
 
 	InvokeObjectPostAlterHook(RelationRelationId, relid, 0);
@@ -15826,7 +15826,7 @@ relation_mark_replica_identity(Relation rel, char ri_type, Oid indexOid,
 	if (!HeapTupleIsValid(pg_class_tuple))
 		elog(ERROR, "cache lookup failed for relation \"%s\"",
 			 RelationGetRelationName(rel));
-	pg_class_form = (Form_pg_class) GETSTRUCT(pg_class_tuple);
+	pg_class_form = GETSTRUCT(pg_class, pg_class_tuple);
 	if (pg_class_form->relreplident != ri_type)
 	{
 		pg_class_form->relreplident = ri_type;
@@ -15846,7 +15846,7 @@ relation_mark_replica_identity(Relation rel, char ri_type, Oid indexOid,
 		pg_index_tuple = SearchSysCache1(INDEXRELID, ObjectIdGetDatum(indexOid));
 		if (!HeapTupleIsValid(pg_index_tuple))
 			elog(ERROR, "cache lookup failed for index %u", indexOid);
-		pg_index_form = (Form_pg_index) GETSTRUCT(pg_index_tuple);
+		pg_index_form = GETSTRUCT(pg_index, pg_index_tuple);
 
 		if (pg_index_form->indisreplident)
 		{
@@ -15870,7 +15870,7 @@ relation_mark_replica_identity(Relation rel, char ri_type, Oid indexOid,
 											 ObjectIdGetDatum(thisIndexOid));
 		if (!HeapTupleIsValid(pg_index_tuple))
 			elog(ERROR, "cache lookup failed for index %u", thisIndexOid);
-		pg_index_form = (Form_pg_index) GETSTRUCT(pg_index_tuple);
+		pg_index_form = GETSTRUCT(pg_index, pg_index_tuple);
 
 		/*
 		 * Unset the bit if set.  We know it's wrong because we checked this
@@ -16040,7 +16040,7 @@ ATExecSetRowSecurity(Relation rel, bool rls)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
 
-	((Form_pg_class) GETSTRUCT(tuple))->relrowsecurity = rls;
+	(GETSTRUCT(pg_class, tuple))->relrowsecurity = rls;
 	CatalogTupleUpdate(pg_class, &tuple->t_self, tuple);
 
 	table_close(pg_class, RowExclusiveLock);
@@ -16066,7 +16066,7 @@ ATExecForceNoForceRowSecurity(Relation rel, bool force_rls)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
 
-	((Form_pg_class) GETSTRUCT(tuple))->relforcerowsecurity = force_rls;
+	(GETSTRUCT(pg_class, tuple))->relforcerowsecurity = force_rls;
 	CatalogTupleUpdate(pg_class, &tuple->t_self, tuple);
 
 	table_close(pg_class, RowExclusiveLock);
@@ -16101,7 +16101,7 @@ ATExecGenericOptions(Relation rel, List *options)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("foreign table \"%s\" does not exist",
 						RelationGetRelationName(rel))));
-	tableform = (Form_pg_foreign_table) GETSTRUCT(tuple);
+	tableform = GETSTRUCT(pg_foreign_table, tuple);
 	server = GetForeignServer(tableform->ftserver);
 	fdw = GetForeignDataWrapper(server->fdwid);
 
@@ -16185,7 +16185,7 @@ ATExecSetCompression(AlteredTableInfo *tab,
 						column, RelationGetRelationName(rel))));
 
 	/* prevent them from altering a system attribute */
-	atttableform = (Form_pg_attribute) GETSTRUCT(tuple);
+	atttableform = GETSTRUCT(pg_attribute, tuple);
 	attnum = atttableform->attnum;
 	if (attnum <= 0)
 		ereport(ERROR,
@@ -16306,7 +16306,7 @@ ATPrepChangePersistence(Relation rel, bool toLogged)
 
 	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
 	{
-		Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(tuple);
+		Form_pg_constraint con = GETSTRUCT(pg_constraint, tuple);
 
 		if (con->contype == CONSTRAINT_FOREIGN)
 		{
@@ -16508,7 +16508,7 @@ AlterRelationNamespaceInternal(Relation classRel, Oid relOid,
 	classTup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(relOid));
 	if (!HeapTupleIsValid(classTup))
 		elog(ERROR, "cache lookup failed for relation %u", relOid);
-	classForm = (Form_pg_class) GETSTRUCT(classTup);
+	classForm = GETSTRUCT(pg_class, classTup);
 
 	Assert(classForm->relnamespace == oldNspOid);
 
@@ -16640,7 +16640,7 @@ AlterSeqNamespaces(Relation classRel, Relation rel,
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_depend depForm = (Form_pg_depend) GETSTRUCT(tup);
+		Form_pg_depend depForm = GETSTRUCT(pg_depend, tup);
 		Relation	seqRel;
 
 		/* skip dependencies other than auto dependencies on columns */
@@ -16966,8 +16966,8 @@ RangeVarCallbackForTruncate(const RangeVar *relation,
 	if (!HeapTupleIsValid(tuple))	/* should not happen */
 		elog(ERROR, "cache lookup failed for relation %u", relId);
 
-	truncate_check_rel(relId, (Form_pg_class) GETSTRUCT(tuple));
-	truncate_check_perms(relId, (Form_pg_class) GETSTRUCT(tuple));
+	truncate_check_rel(relId, GETSTRUCT(pg_class, tuple));
+	truncate_check_perms(relId, GETSTRUCT(pg_class, tuple));
 
 	ReleaseSysCache(tuple);
 }
@@ -16995,7 +16995,7 @@ RangeVarCallbackOwnsRelation(const RangeVar *relation,
 					   relation->relname);
 
 	if (!allowSystemTableMods &&
-		IsSystemClass(relId, (Form_pg_class) GETSTRUCT(tuple)))
+		IsSystemClass(relId, GETSTRUCT(pg_class, tuple)))
 		ereport(ERROR,
 				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
 				 errmsg("permission denied: \"%s\" is a system catalog",
@@ -17022,7 +17022,7 @@ RangeVarCallbackForAlterRelation(const RangeVar *rv, Oid relid, Oid oldrelid,
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		return;					/* concurrently dropped */
-	classform = (Form_pg_class) GETSTRUCT(tuple);
+	classform = GETSTRUCT(pg_class, tuple);
 	relkind = classform->relkind;
 
 	/* Must own relation. */
@@ -17246,7 +17246,7 @@ ComputePartitionAttrs(ParseState *pstate, Relation rel, List *partParams, AttrNu
 						 errmsg("column \"%s\" named in partition key does not exist",
 								pelem->name),
 						 parser_errposition(pstate, pelem->location)));
-			attform = (Form_pg_attribute) GETSTRUCT(atttuple);
+			attform = GETSTRUCT(pg_attribute, atttuple);
 
 			if (attform->attnum <= 0)
 				ereport(ERROR,
@@ -18154,7 +18154,7 @@ CloneRowTriggersToPartition(Relation parent, Relation partition)
 
 	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
 	{
-		Form_pg_trigger trigForm = (Form_pg_trigger) GETSTRUCT(tuple);
+		Form_pg_trigger trigForm = GETSTRUCT(pg_trigger, tuple);
 		CreateTrigStmt *trigStmt;
 		Node	   *qual = NULL;
 		Datum		value;
@@ -18508,7 +18508,7 @@ DetachPartitionFinalize(Relation rel, Relation partRel, bool concurrent,
 		contup = SearchSysCache1(CONSTROID, ObjectIdGetDatum(fk->conoid));
 		if (!HeapTupleIsValid(contup))
 			elog(ERROR, "cache lookup failed for constraint %u", fk->conoid);
-		conform = (Form_pg_constraint) GETSTRUCT(contup);
+		conform = GETSTRUCT(pg_constraint, contup);
 
 		/* consider only the inherited foreign keys */
 		if (conform->contype != CONSTRAINT_FOREIGN ||
@@ -18613,7 +18613,7 @@ DetachPartitionFinalize(Relation rel, Relation partRel, bool concurrent,
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u",
 			 RelationGetRelid(partRel));
-	Assert(((Form_pg_class) GETSTRUCT(tuple))->relispartition);
+	Assert((GETSTRUCT(pg_class, tuple))->relispartition);
 
 	/* Clear relpartbound and reset relispartition */
 	memset(new_val, 0, sizeof(new_val));
@@ -18625,7 +18625,7 @@ DetachPartitionFinalize(Relation rel, Relation partRel, bool concurrent,
 	newtuple = heap_modify_tuple(tuple, RelationGetDescr(classRel),
 								 new_val, new_null, new_repl);
 
-	((Form_pg_class) GETSTRUCT(newtuple))->relispartition = false;
+	(GETSTRUCT(pg_class, newtuple))->relispartition = false;
 	CatalogTupleUpdate(classRel, &newtuple->t_self, newtuple);
 	heap_freetuple(newtuple);
 	table_close(classRel, RowExclusiveLock);
@@ -18775,7 +18775,7 @@ DropClonedTriggersFromPartition(Oid partitionId)
 							  true, NULL, 1, &skey);
 	while (HeapTupleIsValid(trigtup = systable_getnext(scan)))
 	{
-		Form_pg_trigger pg_trigger = (Form_pg_trigger) GETSTRUCT(trigtup);
+		Form_pg_trigger pg_trigger = GETSTRUCT(pg_trigger, trigtup);
 		ObjectAddress trig;
 
 		/* Ignore triggers that weren't cloned */
@@ -18862,7 +18862,7 @@ RangeVarCallbackForAttachIndex(const RangeVar *rv, Oid relOid, Oid oldRelOid,
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relOid));
 	if (!HeapTupleIsValid(tuple))
 		return;					/* concurrently dropped, so nothing to do */
-	classform = (Form_pg_class) GETSTRUCT(tuple);
+	classform = GETSTRUCT(pg_class, tuple);
 	if (classform->relkind != RELKIND_PARTITIONED_INDEX &&
 		classform->relkind != RELKIND_INDEX)
 		ereport(ERROR,
@@ -19083,7 +19083,7 @@ validatePartitionedIndex(Relation partedIdx, Relation partedTbl)
 							  NULL, 1, &key);
 	while ((inhTup = systable_getnext(scan)) != NULL)
 	{
-		Form_pg_inherits inhForm = (Form_pg_inherits) GETSTRUCT(inhTup);
+		Form_pg_inherits inhForm = GETSTRUCT(pg_inherits, inhTup);
 		HeapTuple	indTup;
 		Form_pg_index indexForm;
 
@@ -19091,7 +19091,7 @@ validatePartitionedIndex(Relation partedIdx, Relation partedTbl)
 								 ObjectIdGetDatum(inhForm->inhrelid));
 		if (!HeapTupleIsValid(indTup))
 			elog(ERROR, "cache lookup failed for index %u", inhForm->inhrelid);
-		indexForm = (Form_pg_index) GETSTRUCT(indTup);
+		indexForm = GETSTRUCT(pg_index, indTup);
 		if (indexForm->indisvalid)
 			tuples += 1;
 		ReleaseSysCache(indTup);
@@ -19113,7 +19113,7 @@ validatePartitionedIndex(Relation partedIdx, Relation partedTbl)
 		idxRel = table_open(IndexRelationId, RowExclusiveLock);
 
 		newtup = heap_copytuple(partedIdx->rd_indextuple);
-		((Form_pg_index) GETSTRUCT(newtup))->indisvalid = true;
+		(GETSTRUCT(pg_index, newtup))->indisvalid = true;
 		updated = true;
 
 		CatalogTupleUpdate(idxRel, &partedIdx->rd_indextuple->t_self, newtup);
@@ -19183,7 +19183,7 @@ GetParentedForeignKeyRefs(Relation partition)
 	scan = systable_beginscan(pg_constraint, InvalidOid, true, NULL, 2, key);
 	while ((tuple = systable_getnext(scan)) != NULL)
 	{
-		Form_pg_constraint constrForm = (Form_pg_constraint) GETSTRUCT(tuple);
+		Form_pg_constraint constrForm = GETSTRUCT(pg_constraint, tuple);
 
 		/*
 		 * We only need to process constraints that are part of larger ones.
@@ -19224,7 +19224,7 @@ ATDetachCheckNoForeignKeyRefs(Relation partition)
 		tuple = SearchSysCache1(CONSTROID, ObjectIdGetDatum(constrOid));
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for constraint %u", constrOid);
-		constrForm = (Form_pg_constraint) GETSTRUCT(tuple);
+		constrForm = GETSTRUCT(pg_constraint, tuple);
 
 		Assert(OidIsValid(constrForm->conparentid));
 		Assert(constrForm->confrelid == RelationGetRelid(partition));
diff --git a/src/backend/commands/tablespace.c b/src/backend/commands/tablespace.c
index c8bdd9992a..36ff46fda3 100644
--- a/src/backend/commands/tablespace.c
+++ b/src/backend/commands/tablespace.c
@@ -474,7 +474,7 @@ DropTableSpace(DropTableSpaceStmt *stmt)
 		return;
 	}
 
-	spcform = (Form_pg_tablespace) GETSTRUCT(tuple);
+	spcform = GETSTRUCT(pg_tablespace, tuple);
 	tablespaceoid = spcform->oid;
 
 	/* Must be tablespace owner */
@@ -1002,7 +1002,7 @@ RenameTableSpace(const char *oldname, const char *newname)
 						oldname)));
 
 	newtuple = heap_copytuple(tup);
-	newform = (Form_pg_tablespace) GETSTRUCT(newtuple);
+	newform = GETSTRUCT(pg_tablespace, newtuple);
 	tspId = newform->oid;
 
 	table_endscan(scan);
@@ -1090,7 +1090,7 @@ AlterTableSpaceOptions(AlterTableSpaceOptionsStmt *stmt)
 				 errmsg("tablespace \"%s\" does not exist",
 						stmt->tablespacename)));
 
-	tablespaceoid = ((Form_pg_tablespace) GETSTRUCT(tup))->oid;
+	tablespaceoid = (GETSTRUCT(pg_tablespace, tup))->oid;
 
 	/* Must be owner of the existing object */
 	if (!pg_tablespace_ownercheck(tablespaceoid, GetUserId()))
@@ -1495,7 +1495,7 @@ get_tablespace_oid(const char *tablespacename, bool missing_ok)
 
 	/* We assume that there can be at most one matching tuple */
 	if (HeapTupleIsValid(tuple))
-		result = ((Form_pg_tablespace) GETSTRUCT(tuple))->oid;
+		result = (GETSTRUCT(pg_tablespace, tuple))->oid;
 	else
 		result = InvalidOid;
 
@@ -1541,7 +1541,7 @@ get_tablespace_name(Oid spc_oid)
 
 	/* We assume that there can be at most one matching tuple */
 	if (HeapTupleIsValid(tuple))
-		result = pstrdup(NameStr(((Form_pg_tablespace) GETSTRUCT(tuple))->spcname));
+		result = pstrdup(NameStr((GETSTRUCT(pg_tablespace, tuple))->spcname));
 	else
 		result = NULL;
 
diff --git a/src/backend/commands/trigger.c b/src/backend/commands/trigger.c
index 13cb516752..5df3368f5b 100644
--- a/src/backend/commands/trigger.c
+++ b/src/backend/commands/trigger.c
@@ -743,7 +743,7 @@ CreateTriggerFiringOn(CreateTrigStmt *stmt, const char *queryString,
 		/* There should be at most one matching tuple */
 		if (HeapTupleIsValid(tuple = systable_getnext(tgscan)))
 		{
-			Form_pg_trigger oldtrigger = (Form_pg_trigger) GETSTRUCT(tuple);
+			Form_pg_trigger oldtrigger = GETSTRUCT(pg_trigger, tuple);
 
 			trigoid = oldtrigger->oid;
 			existing_constraint_oid = oldtrigger->tgconstraint;
@@ -1029,9 +1029,9 @@ CreateTriggerFiringOn(CreateTrigStmt *stmt, const char *queryString,
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u",
 			 RelationGetRelid(rel));
-	if (!((Form_pg_class) GETSTRUCT(tuple))->relhastriggers)
+	if (!(GETSTRUCT(pg_class, tuple))->relhastriggers)
 	{
-		((Form_pg_class) GETSTRUCT(tuple))->relhastriggers = true;
+		(GETSTRUCT(pg_class, tuple))->relhastriggers = true;
 
 		CatalogTupleUpdate(pgrel, &tuple->t_self, tuple);
 
@@ -1290,7 +1290,7 @@ TriggerSetParentTrigger(Relation trigRel,
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "could not find tuple for trigger %u", childTrigId);
 	newtup = heap_copytuple(tuple);
-	trigForm = (Form_pg_trigger) GETSTRUCT(newtup);
+	trigForm = GETSTRUCT(pg_trigger, newtup);
 	if (OidIsValid(parentTrigId))
 	{
 		/* don't allow setting parent for a constraint that already has one */
@@ -1362,7 +1362,7 @@ RemoveTriggerById(Oid trigOid)
 	/*
 	 * Open and exclusive-lock the relation the trigger belongs to.
 	 */
-	relid = ((Form_pg_trigger) GETSTRUCT(tup))->tgrelid;
+	relid = (GETSTRUCT(pg_trigger, tup))->tgrelid;
 
 	rel = table_open(relid, AccessExclusiveLock);
 
@@ -1450,7 +1450,7 @@ get_trigger_oid(Oid relid, const char *trigname, bool missing_ok)
 	}
 	else
 	{
-		oid = ((Form_pg_trigger) GETSTRUCT(tup))->oid;
+		oid = (GETSTRUCT(pg_trigger, tup))->oid;
 	}
 
 	systable_endscan(tgscan);
@@ -1471,7 +1471,7 @@ RangeVarCallbackForRenameTrigger(const RangeVar *rv, Oid relid, Oid oldrelid,
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		return;					/* concurrently dropped */
-	form = (Form_pg_class) GETSTRUCT(tuple);
+	form = GETSTRUCT(pg_class, tuple);
 
 	/* only tables and views can have triggers */
 	if (form->relkind != RELKIND_RELATION && form->relkind != RELKIND_VIEW &&
@@ -1558,7 +1558,7 @@ renametrig(RenameStmt *stmt)
 	{
 		Form_pg_trigger trigform;
 
-		trigform = (Form_pg_trigger) GETSTRUCT(tuple);
+		trigform = GETSTRUCT(pg_trigger, tuple);
 		tgoid = trigform->oid;
 
 		/*
@@ -1632,7 +1632,7 @@ renametrig_internal(Relation tgrel, Relation targetrel, HeapTuple trigtup,
 	SysScanDesc tgscan;
 
 	/* If the trigger already has the new name, nothing to do. */
-	tgform = (Form_pg_trigger) GETSTRUCT(trigtup);
+	tgform = GETSTRUCT(pg_trigger, trigtup);
 	if (strcmp(NameStr(tgform->tgname), newname) == 0)
 		return;
 
@@ -1662,7 +1662,7 @@ renametrig_internal(Relation tgrel, Relation targetrel, HeapTuple trigtup,
 	 * The target name is free; update the existing pg_trigger tuple with it.
 	 */
 	tuple = heap_copytuple(trigtup);	/* need a modifiable copy */
-	tgform = (Form_pg_trigger) GETSTRUCT(tuple);
+	tgform = GETSTRUCT(pg_trigger, tuple);
 
 	/*
 	 * If the trigger has a name different from what we expected, let the user
@@ -1714,7 +1714,7 @@ renametrig_partition(Relation tgrel, Oid partitionId, Oid parentTriggerOid,
 								NULL, 1, &key);
 	while (HeapTupleIsValid(tuple = systable_getnext(tgscan)))
 	{
-		Form_pg_trigger tgform = (Form_pg_trigger) GETSTRUCT(tuple);
+		Form_pg_trigger tgform = GETSTRUCT(pg_trigger, tuple);
 		Relation	partitionRel;
 
 		if (tgform->tgparentid != parentTriggerOid)
@@ -1801,7 +1801,7 @@ EnableDisableTrigger(Relation rel, const char *tgname,
 
 	while (HeapTupleIsValid(tuple = systable_getnext(tgscan)))
 	{
-		Form_pg_trigger oldtrig = (Form_pg_trigger) GETSTRUCT(tuple);
+		Form_pg_trigger oldtrig = GETSTRUCT(pg_trigger, tuple);
 
 		if (oldtrig->tgisinternal)
 		{
@@ -1821,7 +1821,7 @@ EnableDisableTrigger(Relation rel, const char *tgname,
 		{
 			/* need to change this one ... make a copy to scribble on */
 			HeapTuple	newtup = heap_copytuple(tuple);
-			Form_pg_trigger newtrig = (Form_pg_trigger) GETSTRUCT(newtup);
+			Form_pg_trigger newtrig = GETSTRUCT(pg_trigger, newtup);
 
 			newtrig->tgenabled = fires_when;
 
@@ -1905,7 +1905,7 @@ RelationBuildTriggers(Relation relation)
 
 	while (HeapTupleIsValid(htup = systable_getnext(tgscan)))
 	{
-		Form_pg_trigger pg_trigger = (Form_pg_trigger) GETSTRUCT(htup);
+		Form_pg_trigger pg_trigger = GETSTRUCT(pg_trigger, htup);
 		Trigger    *build;
 		Datum		datum;
 		bool		isnull;
@@ -5709,7 +5709,7 @@ AfterTriggerSetState(ConstraintsSetStmt *stmt)
 
 				while (HeapTupleIsValid(tup = systable_getnext(conscan)))
 				{
-					Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(tup);
+					Form_pg_constraint con = GETSTRUCT(pg_constraint, tup);
 
 					if (con->condeferrable)
 						conoidlist = lappend_oid(conoidlist, con->oid);
@@ -5765,7 +5765,7 @@ AfterTriggerSetState(ConstraintsSetStmt *stmt)
 
 			while (HeapTupleIsValid(tuple = systable_getnext(scan)))
 			{
-				Form_pg_constraint con = (Form_pg_constraint) GETSTRUCT(tuple);
+				Form_pg_constraint con = GETSTRUCT(pg_constraint, tuple);
 
 				conoidlist = lappend_oid(conoidlist, con->oid);
 			}
@@ -5798,7 +5798,7 @@ AfterTriggerSetState(ConstraintsSetStmt *stmt)
 
 			while (HeapTupleIsValid(htup = systable_getnext(tgscan)))
 			{
-				Form_pg_trigger pg_trigger = (Form_pg_trigger) GETSTRUCT(htup);
+				Form_pg_trigger pg_trigger = GETSTRUCT(pg_trigger, htup);
 
 				/*
 				 * Silently skip triggers that are marked as non-deferrable in
diff --git a/src/backend/commands/tsearchcmds.c b/src/backend/commands/tsearchcmds.c
index 4cc4e3c00f..164379934a 100644
--- a/src/backend/commands/tsearchcmds.c
+++ b/src/backend/commands/tsearchcmds.c
@@ -130,7 +130,7 @@ get_ts_parser_func(DefElem *defel, int attnum)
 static ObjectAddress
 makeParserDependencies(HeapTuple tuple)
 {
-	Form_pg_ts_parser prs = (Form_pg_ts_parser) GETSTRUCT(tuple);
+	Form_pg_ts_parser prs = GETSTRUCT(pg_ts_parser, tuple);
 	ObjectAddress myself,
 				referenced;
 	ObjectAddresses *addrs;
@@ -300,7 +300,7 @@ DefineTSParser(List *names, List *parameters)
 static ObjectAddress
 makeDictionaryDependencies(HeapTuple tuple)
 {
-	Form_pg_ts_dict dict = (Form_pg_ts_dict) GETSTRUCT(tuple);
+	Form_pg_ts_dict dict = GETSTRUCT(pg_ts_dict, tuple);
 	ObjectAddress myself,
 				referenced;
 	ObjectAddresses *addrs;
@@ -353,7 +353,7 @@ verify_dictoptions(Oid tmplId, List *dictoptions)
 	if (!HeapTupleIsValid(tup)) /* should not happen */
 		elog(ERROR, "cache lookup failed for text search template %u",
 			 tmplId);
-	tform = (Form_pg_ts_template) GETSTRUCT(tup);
+	tform = GETSTRUCT(pg_ts_template, tup);
 
 	initmethod = tform->tmplinit;
 
@@ -552,7 +552,7 @@ AlterTSDictionary(AlterTSDictionaryStmt *stmt)
 	/*
 	 * Validate
 	 */
-	verify_dictoptions(((Form_pg_ts_dict) GETSTRUCT(tup))->dicttemplate,
+	verify_dictoptions((GETSTRUCT(pg_ts_dict, tup))->dicttemplate,
 					   dictoptions);
 
 	/*
@@ -645,7 +645,7 @@ get_ts_template_func(DefElem *defel, int attnum)
 static ObjectAddress
 makeTSTemplateDependencies(HeapTuple tuple)
 {
-	Form_pg_ts_template tmpl = (Form_pg_ts_template) GETSTRUCT(tuple);
+	Form_pg_ts_template tmpl = GETSTRUCT(pg_ts_template, tuple);
 	ObjectAddress myself,
 				referenced;
 	ObjectAddresses *addrs;
@@ -806,7 +806,7 @@ static ObjectAddress
 makeConfigurationDependencies(HeapTuple tuple, bool removeOld,
 							  Relation mapRel)
 {
-	Form_pg_ts_config cfg = (Form_pg_ts_config) GETSTRUCT(tuple);
+	Form_pg_ts_config cfg = GETSTRUCT(pg_ts_config, tuple);
 	ObjectAddresses *addrs;
 	ObjectAddress myself,
 				referenced;
@@ -867,7 +867,7 @@ makeConfigurationDependencies(HeapTuple tuple, bool removeOld,
 
 		while (HeapTupleIsValid((maptup = systable_getnext(scan))))
 		{
-			Form_pg_ts_config_map cfgmap = (Form_pg_ts_config_map) GETSTRUCT(maptup);
+			Form_pg_ts_config_map cfgmap = GETSTRUCT(pg_ts_config_map, maptup);
 
 			referenced.classId = TSDictionaryRelationId;
 			referenced.objectId = cfgmap->mapdict;
@@ -959,7 +959,7 @@ DefineTSConfiguration(List *names, List *parameters, ObjectAddress *copied)
 			elog(ERROR, "cache lookup failed for text search configuration %u",
 				 sourceOid);
 
-		cfg = (Form_pg_ts_config) GETSTRUCT(tup);
+		cfg = GETSTRUCT(pg_ts_config, tup);
 
 		/* use source's parser */
 		prsOid = cfg->cfgparser;
@@ -1017,7 +1017,7 @@ DefineTSConfiguration(List *names, List *parameters, ObjectAddress *copied)
 
 		while (HeapTupleIsValid((maptup = systable_getnext(scan))))
 		{
-			Form_pg_ts_config_map cfgmap = (Form_pg_ts_config_map) GETSTRUCT(maptup);
+			Form_pg_ts_config_map cfgmap = GETSTRUCT(pg_ts_config_map, maptup);
 			HeapTuple	newmaptup;
 			Datum		mapvalues[Natts_pg_ts_config_map];
 			bool		mapnulls[Natts_pg_ts_config_map];
@@ -1121,7 +1121,7 @@ AlterTSConfiguration(AlterTSConfigurationStmt *stmt)
 				 errmsg("text search configuration \"%s\" does not exist",
 						NameListToString(stmt->cfgname))));
 
-	cfgId = ((Form_pg_ts_config) GETSTRUCT(tup))->oid;
+	cfgId = (GETSTRUCT(pg_ts_config, tup))->oid;
 
 	/* must be owner */
 	if (!pg_ts_config_ownercheck(cfgId, GetUserId()))
@@ -1226,7 +1226,7 @@ MakeConfigurationMapping(AlterTSConfigurationStmt *stmt,
 	int			ndict;
 	ListCell   *c;
 
-	tsform = (Form_pg_ts_config) GETSTRUCT(tup);
+	tsform = GETSTRUCT(pg_ts_config, tup);
 	cfgId = tsform->oid;
 	prsId = tsform->cfgparser;
 
@@ -1293,7 +1293,7 @@ MakeConfigurationMapping(AlterTSConfigurationStmt *stmt,
 
 		while (HeapTupleIsValid((maptup = systable_getnext(scan))))
 		{
-			Form_pg_ts_config_map cfgmap = (Form_pg_ts_config_map) GETSTRUCT(maptup);
+			Form_pg_ts_config_map cfgmap = GETSTRUCT(pg_ts_config_map, maptup);
 
 			/*
 			 * check if it's one of target token types
@@ -1386,7 +1386,7 @@ DropConfigurationMapping(AlterTSConfigurationStmt *stmt,
 	int		   *tokens;
 	ListCell   *c;
 
-	tsform = (Form_pg_ts_config) GETSTRUCT(tup);
+	tsform = GETSTRUCT(pg_ts_config, tup);
 	cfgId = tsform->oid;
 	prsId = tsform->cfgparser;
 
